@echo off


setlocal


set "kTaskName=DomainLogonConfig"


if /i "%1"=="install" goto Install
if /i "%1"=="inst" goto Install
if /i "%1"=="add" goto Install

if /i "%1"=="uninstall" goto Uninst
if /i "%1"=="uninst" goto Uninst
if /i "%1"=="remove" goto Uninst
if /i "%1"=="rm" goto Uninst
if /i "%1"=="delete" goto Uninst
if /i "%1"=="del" goto Uninst

goto Main


:Install
    schtasks /Create /RU "NT AUTHORITY\SYSTEM" /SC ONLOGON ^
      /TN "%kTaskName%" /TR "%~f0"
exit /B 0


:Uninst
    schtasks /Delete /TN "%kTaskName%" /F
exit /B 0


:Main
    setlocal

    set "kRegKey_Msft=HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft"
    set "kRegKey_Policy=%kRegKey_Msft%\Windows\CurrentVersion\Policies\System"
    set "kRegKey_Winlogon=%kRegKey_Msft%\Windows NT\CurrentVersion\Winlogon"
    set "kRegVal_DefLgDomain=DefaultLogonDomain"
        
    reg add "%kRegKey_Winlogon%" /v RasDisable /t REG_SZ /d "1" /f
    reg add "%kRegKey_Winlogon%" /v ShowLogonOptions /t REG_DWORD /d 1 /f

    for /F "skip=4 tokens=1,2*" %%A in ('reg query ^
      "%kRegKey_Policy%" /v "%kRegVal_DefLgDomain%" 2^> NUL:') do (
        set "gDomainName=%%C"
        if not "%%A"=="%kRegVal_DefLgDomain%" set "gDomainName="
        if not "%%B"=="REG_SZ" set "gDomainName="
    )

    if not "%gDomainName%"=="" (
        reg add "%kRegKey_Winlogon%" /v AltDefaultDomainName ^
          /t REG_SZ /d "%gDomainName%" /f
        reg add "%kRegKey_Winlogon%" /v DefaultDomainName ^
          /t REG_SZ /d "%gDomainName%" /f
    )
exit /B 0
